package com.zipcodewilmington.looplabs;

/**
 * Created by leon on 1/28/18.
 * @ATTENTION_TO_STUDENTS You are forbidden from modifying the signature of this class.
 */
public final class StringDuplicateDeleter extends DuplicateDeleter<String> {

    public StringDuplicateDeleter(String[] intArray) {
        super(intArray);
    }

    @Override
    public String[] removeDuplicates(int maxNumberOfDuplications) {
        String[] newArr = createEmptyArrayWithOutDuplicatesNotExact(maxNumberOfDuplications);
        int index = 0;
        for(int i = 0; i < super.array.length; i ++){
            String word = super.array[i];
            int amount = findDuplicateOfElement(word);
            if(amount >= maxNumberOfDuplications){
                Integer[] indexes = getIndexsOfElements(word);
                i = indexes[indexes.length - 1];
            } else {
                newArr[index] = array[i];
                index ++;
            }
        }
        return newArr;
    }

    @Override
    public String[] removeDuplicatesExactly(int exactNumberOfDuplications) {
        String[] newArr = createEmptyArrayWithOutDuplicatesExact(exactNumberOfDuplications);
        int index = 0;
        for(int i = 0; i < super.array.length; i ++){
            int amount = findDuplicateOfElement(super.array[i]);
            String word = super.array[i];
            if(amount == exactNumberOfDuplications){
                Integer[] indexes = getIndexsOfElements(word);
                i = indexes[indexes.length - 1];
            } else {
                newArr[index] = word;
                index ++;
            }
        }
        return newArr;
    }

    public String[] createEmptyArrayWithOutDuplicatesNotExact(Integer maxNumberOfDuplications){
        int removeAmount = 0;
        for(int i = 0; i < array.length; i ++){
            Integer[] indexes = getIndexsOfElements(array[i]);
            if(indexes.length >= maxNumberOfDuplications) {
                removeAmount += indexes.length;
                i = indexes[indexes.length - 1];
            }
        }
        return new String[array.length - removeAmount];
    }

    public String[] createEmptyArrayWithOutDuplicatesExact(Integer maxNumberOfDuplications){
        int removeAmount = 0;
        for(int i = 0; i < array.length; i ++){
            Integer[] indexes = getIndexsOfElements(array[i]);
            if(indexes.length == maxNumberOfDuplications) {
                removeAmount += indexes.length;
                i = indexes[indexes.length - 1];
            }
        }
        return new String[array.length - removeAmount];
    }

    public Integer[] getIndexsOfElements(String element){
        Integer[] indexes = new Integer[findDuplicateOfElement(element)];
        for(int i = 0; i < indexes.length; i ++){
            for(int j = 0; j < super.array.length; j ++){
                if(super.array[j].equals(element)){
                    if(!containsIndex(indexes, j)){
                        indexes[i] = j;
                        break;
                    }
                }
            }
        }
        return indexes;
    }

    public int findDuplicateOfElement(String element){
        int count = 0;
        for(String s : super.array){
            if(s.equals(element)){
                count ++;
            }
        }
        return count;
    }

    public boolean containsIndex(Integer[] arr, Integer element){
        for(Integer i : arr){
            if(i != null) {
                if (i.equals(element)) {
                    return true;
                }
            }
        }
        return false;
    }
}
